Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/HeuristicLab.Algorithms.EGO-3.4.csproj
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/HeuristicLab.Algorithms.EGO-3.4.csproj	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/HeuristicLab.Algorithms.EGO-3.4.csproj	(revision 15064)
@@ -39,8 +39,4 @@
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Algorithms.DataAnalysis-3.4.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.Algorithms.EvolutionStrategy-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Algorithms.EvolutionStrategy-3.3.dll</HintPath>
-    </Reference>
     <Reference Include="HeuristicLab.Analysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -55,8 +51,4 @@
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.Common.Resources-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Common.Resources-3.3.dll</HintPath>
-    </Reference>
     <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -66,4 +58,8 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.PermutationEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Encodings.PermutationEncoding-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Encodings.RealVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -75,4 +71,8 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization.Operators-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Optimization.Operators-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Parameters-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -92,15 +92,8 @@
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.DataAnalysis-3.4.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+    <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec" />
+    <Reference Include="HeuristicLab.Problems.SurrogateProblem-3.3, Version=3.3.0.0, Culture=neutral, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
-    </Reference>
-    <Reference Include="HeuristicLab.Problems.Instances.DataAnalysis-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances.DataAnalysis-3.3.dll</HintPath>
-    </Reference>
-    <Reference Include="HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3.dll</HintPath>
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.SurrogateProblem-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Random-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -108,13 +101,8 @@
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Random-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="Microsoft.Build.Tasks.v4.0" />
     <Reference Include="System" />
     <Reference Include="System.Core" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Xml.Linq" />
-    <Reference Include="System.Data.DataSetExtensions" />
     <Reference Include="Microsoft.CSharp" />
-    <Reference Include="System.Data" />
-    <Reference Include="System.Net.Http" />
-    <Reference Include="System.Xml" />
   </ItemGroup>
   <ItemGroup>
@@ -122,7 +110,8 @@
     <Compile Include="EfficientGlobalOptimizationAlgorithm.cs" />
     <Compile Include="InfillCriteria\AugmentedExpectedImprovement.cs" />
+    <Compile Include="InfillCriteria\ExpectedImprovementBase.cs" />
+    <Compile Include="InfillCriteria\NeighbourDistance.cs" />
     <Compile Include="InfillCriteria\ExpectedQuantileImprovement.cs" />
     <Compile Include="InfillCriteria\PluginExpectedImprovement.cs" />
-    <Compile Include="InfillCriteria\RobustImprovement.cs" />
     <Compile Include="InfillCriteria\MinimalQuantileCriterium.cs" />
     <Compile Include="InfillCriteria\ExpectedQuality.cs" />
@@ -132,8 +121,18 @@
     <Compile Include="Interfaces\ISurrogateAlgorithm.cs" />
     <Compile Include="Interfaces\IInfillCriterion.cs" />
+    <Compile Include="AdaptiveSamplingAlgorithm.cs" />
+    <Compile Include="Operators\FitnessClusteringAnalyzer.cs" />
+    <Compile Include="Operators\VariableVariabilityAnalyzer.cs" />
+    <Compile Include="Operators\ModelQualityAnalyzer.cs" />
+    <Compile Include="Operators\EvaluatedSolutionsAnalyzer.cs" />
+    <Compile Include="Operators\ModelBuilder.cs" />
+    <Compile Include="Operators\InfillSolver.cs" />
+    <Compile Include="Operators\CorrelationAnalyzer.cs" />
+    <Compile Include="Operators\SampleCollector.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Problems\InfillProblem.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="SamplingMethods\LatinHyperCubeDesign.cs" />
+    <Compile Include="SamplingMethods\LatinHyperCubeDesignOLD.cs" />
+    <Compile Include="SamplingMethods\LatinHyperCubeDesignCreator.cs" />
     <Compile Include="SamplingMethods\UniformRandomSampling.cs" />
   </ItemGroup>
@@ -142,7 +141,5 @@
     <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
-  <ItemGroup>
-    <WCFMetadata Include="Service References\" />
-  </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/AugmentedExpectedImprovement.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/AugmentedExpectedImprovement.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/AugmentedExpectedImprovement.cs	(revision 15064)
@@ -35,40 +35,28 @@
   [StorableClass]
   [Item("AugmentedExpectedImprovement", "Noisy InfillCriterion, Extension of the Expected Improvement as described in\n Global optimization of stochastic black-box systems via sequential kriging meta-models.\r\nHuang, D., Allen, T., Notz, W., Zeng, N.")]
-  public class AugmentedExpectedImprovement : ExpectedImprovement {
-
-
+  public class AugmentedExpectedImprovement : ExpectedImprovementBase {
 
     #region Parameternames
-
     public const string AlphaParameterName = "Alpha";
-
     #endregion
 
     #region Parameters
-
     public IValueParameter<DoubleValue> AlphaParameter => Parameters[AlphaParameterName] as IValueParameter<DoubleValue>;
-
     #endregion
 
     #region Properties
-
     public double Alpha => AlphaParameter.Value.Value;
     [Storable]
     private double Tau;
-
     #endregion
 
-
-    #region HL-Constructors, Serialization and Cloning 
+    #region Constructors, Serialization and Cloning 
     [StorableConstructor]
-    private AugmentedExpectedImprovement(bool deserializing) : base(deserializing) { }
-
-    private AugmentedExpectedImprovement(AugmentedExpectedImprovement original, Cloner cloner) : base(original, cloner) {
+    protected AugmentedExpectedImprovement(bool deserializing) : base(deserializing) { }
+    protected AugmentedExpectedImprovement(AugmentedExpectedImprovement original, Cloner cloner) : base(original, cloner) {
       Tau = original.Tau;
     }
-
     public AugmentedExpectedImprovement() {
       Parameters.Add(new ValueParameter<DoubleValue>(AlphaParameterName, "The Alpha value specifiying the robustness of the \"effective best solution\". Recommended value is 1", new DoubleValue(1.0)));
-
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -82,16 +70,16 @@
     }
 
-    protected override void Initialize() {
-      if (ExpensiveMaximization) throw new NotImplementedException("AugmentedExpectedImprovement for maximization not yet implemented");
-      var solution = RegressionSolution as IConfidenceRegressionSolution;
-      if (solution == null) throw new ArgumentException("can not calculate Augmented EI without a regression solution providing confidence values");
+    protected override double Evaluate(RealVector vector, double estimatedFitness, double estimatedStandardDeviation) {
+      var d = GetEstimatedImprovement(BestFitness, estimatedFitness, estimatedStandardDeviation, ExploitationWeight, ExpensiveMaximization);
+      return d * (1 - Tau / Math.Sqrt(estimatedStandardDeviation * estimatedStandardDeviation + Tau * Tau));
+    }
 
+    protected override double FindBestFitness(IConfidenceRegressionSolution solution) {
       Tau = RegressionSolution.EstimatedTrainingValues.Zip(RegressionSolution.ProblemData.TargetVariableTrainingValues, (d, d1) => Math.Abs(d - d1)).Average();
-      var xss = new RealVector(Encoding.Length);
+      var bestSolution = new RealVector(Encoding.Length);
       var xssIndex = solution.EstimatedTrainingValues.Zip(solution.EstimatedTrainingValues, (m, s2) => m + Alpha * Math.Sqrt(s2)).ArgMin(x => x);
       var i = solution.ProblemData.TrainingIndices.ToArray()[xssIndex];
-      for (var j = 0; j < Encoding.Length; j++) xss[j] = solution.ProblemData.Dataset.GetDoubleValue(i, j);
-
-      YMin = RegressionSolution.Model.GetEstimation(xss);
+      for (var j = 0; j < Encoding.Length; j++) bestSolution[j] = solution.ProblemData.Dataset.GetDoubleValue(i, j);
+      return RegressionSolution.Model.GetEstimation(bestSolution);
     }
   }
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedImprovement.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedImprovement.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedImprovement.cs	(revision 15064)
@@ -24,7 +24,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.RealVectorEncoding;
-using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.DataAnalysis;
@@ -35,36 +33,10 @@
   [StorableClass]
   [Item("ExpectedImprovementMeassure", "Extension of the Expected Improvement to a weighted version by ANDRAS SÓBESTER , STEPHEN J. LEARY and ANDY J. KEANE   in \n On the Design of Optimization Strategies Based on Global Response Surface Approximation Models")]
-  public class ExpectedImprovement : InfillCriterionBase {
-
-    #region ParameterNames
-    private const string ExploitationWeightParameterName = "ExploitationWeight";
-    #endregion
-
-    #region ParameterProperties
-    public IFixedValueParameter<DoubleValue> ExploitationWeightParameter => Parameters[ExploitationWeightParameterName] as IFixedValueParameter<DoubleValue>;
-
-    #endregion
-
-    #region Properties
-    protected double ExploitationWeight => ExploitationWeightParameter.Value.Value;
-
-    [Storable]
-    protected double YMin;
-    #endregion
-
-    #region HL-Constructors, Serialization and Cloning 
+  public sealed class ExpectedImprovement : ExpectedImprovementBase {
+    #region Constructors, Serialization and Cloning 
     [StorableConstructor]
-    protected ExpectedImprovement(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      RegisterEventhandlers();
-    }
-    protected ExpectedImprovement(ExpectedImprovement original, Cloner cloner) : base(original, cloner) {
-      RegisterEventhandlers();
-    }
-    public ExpectedImprovement() {
-      Parameters.Add(new FixedValueParameter<DoubleValue>(ExploitationWeightParameterName, "A value between 0 and 1 indicating the focus on exploration (0) or exploitation (1)", new DoubleValue(0.5)));
-      RegisterEventhandlers();
-    }
+    private ExpectedImprovement(bool deserializing) : base(deserializing) { }
+    private ExpectedImprovement(ExpectedImprovement original, Cloner cloner) : base(original, cloner) { }
+    public ExpectedImprovement() { }
     public override IDeepCloneable Clone(Cloner cloner) {
       return new ExpectedImprovement(this, cloner);
@@ -76,63 +48,14 @@
       var yhat = model.GetEstimation(vector);
       var s = Math.Sqrt(model.GetVariance(vector));
-      return GetEstimatedImprovement(YMin, yhat, s, ExploitationWeight);
+      return GetEstimatedImprovement(BestFitness, yhat, s, ExploitationWeight, ExpensiveMaximization);
     }
 
-    public override bool Maximization() {
-      return true;
+    protected override double Evaluate(RealVector vector, double estimatedFitness, double estimatedStandardDeviation) {
+      return GetEstimatedImprovement(BestFitness, estimatedFitness, estimatedStandardDeviation, ExploitationWeight, ExpensiveMaximization);
     }
 
-    protected override void Initialize() {
-      if (ExpensiveMaximization) throw new NotImplementedException("Expected Improvement for maximization not yet implemented");
-      var model = RegressionSolution.Model as IConfidenceRegressionModel;
-      if (model == null) throw new ArgumentException("can not calculate EI without confidence measure");
-      YMin = RegressionSolution.ProblemData.TargetVariableTrainingValues.Min();
+    protected override double FindBestFitness(IConfidenceRegressionSolution solution) {
+      return ExpensiveMaximization ? solution.ProblemData.TargetVariableTrainingValues.Max() : solution.ProblemData.TargetVariableTrainingValues.Min();
     }
-
-    #region Eventhandling
-    private void RegisterEventhandlers() {
-      DeregisterEventhandlers();
-      ExploitationWeightParameter.Value.ValueChanged += OnExploitationWeightChanged;
-    }
-    private void DeregisterEventhandlers() {
-      ExploitationWeightParameter.Value.ValueChanged -= OnExploitationWeightChanged;
-    }
-    private void OnExploitationWeightChanged(object sender, EventArgs e) {
-      ExploitationWeightParameter.Value.ValueChanged -= OnExploitationWeightChanged;
-      ExploitationWeightParameter.Value.Value = Math.Max(0, Math.Min(ExploitationWeight, 1));
-      ExploitationWeightParameter.Value.ValueChanged += OnExploitationWeightChanged;
-    }
-    #endregion
-
-    #region Helpers
-    protected static double GetEstimatedImprovement(double ymin, double yhat, double s, double w) {
-      if (Math.Abs(s) < double.Epsilon) return 0;
-      var val = (ymin - yhat) / s;
-      var res = w * (ymin - yhat) * StandardNormalDistribution(val) + (1 - w) * s * StandardNormalDensity(val);
-      return double.IsInfinity(res) || double.IsNaN(res) ? 0 : res;
-    }
-
-    private static double StandardNormalDensity(double x) {
-      if (Math.Abs(x) > 10) return 0;
-      return Math.Exp(-0.5 * x * x) / Math.Sqrt(2 * Math.PI);
-    }
-
-    //taken from https://www.johndcook.com/blog/2009/01/19/stand-alone-error-function-erf/
-    private static double StandardNormalDistribution(double x) {
-      if (x > 10) return 1;
-      if (x < -10) return 0;
-      const double a1 = 0.254829592;
-      const double a2 = -0.284496736;
-      const double a3 = 1.421413741;
-      const double a4 = -1.453152027;
-      const double a5 = 1.061405429;
-      const double p = 0.3275911;
-      var sign = x < 0 ? -1 : 1;
-      x = Math.Abs(x) / Math.Sqrt(2.0);
-      var t = 1.0 / (1.0 + p * x);
-      var y = 1.0 - ((((a5 * t + a4) * t + a3) * t + a2) * t + a1) * t * Math.Exp(-x * x);
-      return 0.5 * (1.0 + sign * y);
-    }
-    #endregion
   }
 }
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedImprovementBase.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedImprovementBase.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedImprovementBase.cs	(revision 15064)
@@ -0,0 +1,130 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+// ReSharper disable once CheckNamespace
+namespace HeuristicLab.Algorithms.EGO {
+
+  [StorableClass]
+  public abstract class ExpectedImprovementBase : InfillCriterionBase {
+
+    #region ParameterNames
+    private const string ExploitationWeightParameterName = "ExploitationWeight";
+    #endregion
+
+    #region ParameterProperties
+    public IFixedValueParameter<DoubleValue> ExploitationWeightParameter => Parameters[ExploitationWeightParameterName] as IFixedValueParameter<DoubleValue>;
+    #endregion
+
+    #region Properties
+    protected double ExploitationWeight => ExploitationWeightParameter.Value.Value;
+    [Storable]
+    protected double BestFitness;
+    #endregion
+
+    #region Constructors, Serialization and Cloning 
+    [StorableConstructor]
+    protected ExpectedImprovementBase(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventhandlers();
+    }
+    protected ExpectedImprovementBase(ExpectedImprovementBase original, Cloner cloner) : base(original, cloner) {
+      BestFitness = original.BestFitness;
+      RegisterEventhandlers();
+    }
+    protected ExpectedImprovementBase() {
+      Parameters.Add(new FixedValueParameter<DoubleValue>(ExploitationWeightParameterName, "A value between 0 and 1 indicating the focus on exploration (0) or exploitation (1). 0.5 equates to the original EI by Jones et al.", new DoubleValue(0.5)));
+      RegisterEventhandlers();
+    }
+    #endregion
+
+    public override void Initialize() {
+      var solution = RegressionSolution as IConfidenceRegressionSolution;
+      if (solution == null) throw new ArgumentException("can not calculate EI without a regression solution providing confidence values");
+      BestFitness = FindBestFitness(solution);
+    }
+
+    protected abstract double FindBestFitness(IConfidenceRegressionSolution solution);
+
+    public override double Evaluate(RealVector vector) {
+      var model = RegressionSolution.Model as IConfidenceRegressionModel;
+      var yhat = model.GetEstimation(vector);
+      var s = Math.Sqrt(model.GetVariance(vector));
+      return Evaluate(vector, yhat, s);
+    }
+
+    protected abstract double Evaluate(RealVector vector, double estimatedFitness, double estimatedStandardDeviation);
+
+    #region Eventhandling
+    private void RegisterEventhandlers() {
+      DeregisterEventhandlers();
+      ExploitationWeightParameter.Value.ValueChanged += OnExploitationWeightChanged;
+    }
+    private void DeregisterEventhandlers() {
+      ExploitationWeightParameter.Value.ValueChanged -= OnExploitationWeightChanged;
+    }
+    private void OnExploitationWeightChanged(object sender, EventArgs e) {
+      ExploitationWeightParameter.Value.ValueChanged -= OnExploitationWeightChanged;
+      ExploitationWeightParameter.Value.Value = Math.Max(0, Math.Min(ExploitationWeight, 1));
+      ExploitationWeightParameter.Value.ValueChanged += OnExploitationWeightChanged;
+    }
+    #endregion
+
+    #region Helpers
+    public static double GetEstimatedImprovement(double bestFitness, double estimatedFitness, double modelUncertainty, double weight, bool maximization) {
+      if (Math.Abs(modelUncertainty) < double.Epsilon) return 0;
+      var diff = maximization ? (estimatedFitness - bestFitness) : (bestFitness - estimatedFitness);
+      var val = diff / modelUncertainty;
+      var res = weight * diff * StandardNormalDistribution(val) + (1 - weight) * modelUncertainty * StandardNormalDensity(val);
+      return double.IsInfinity(res) || double.IsNaN(res) ? 0 : res;
+    }
+    private static double StandardNormalDensity(double x) {
+      if (Math.Abs(x) > 10) return 0;
+      return Math.Exp(-0.5 * x * x) / Math.Sqrt(2 * Math.PI);
+    }
+    //taken from https://www.johndcook.com/blog/2009/01/19/stand-alone-error-function-erf/
+    private static double StandardNormalDistribution(double x) {
+      if (x > 10) return 1;
+      if (x < -10) return 0;
+      const double a1 = 0.254829592;
+      const double a2 = -0.284496736;
+      const double a3 = 1.421413741;
+      const double a4 = -1.453152027;
+      const double a5 = 1.061405429;
+      const double p = 0.3275911;
+      var sign = x < 0 ? -1 : 1;
+      x = Math.Abs(x) / Math.Sqrt(2.0);
+      var t = 1.0 / (1.0 + p * x);
+      var y = 1.0 - ((((a5 * t + a4) * t + a3) * t + a2) * t + a1) * t * Math.Exp(-x * x);
+      return 0.5 * (1.0 + sign * y);
+    }
+    #endregion
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedQuality.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedQuality.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedQuality.cs	(revision 15064)
@@ -29,10 +29,10 @@
 
   [StorableClass]
-  [Item("ExpectedQualityMeassure", "Use simply the qualitypredicted by the model")]
+  [Item("ExpectedQualityMeassure", "Use the quality predicted by the model")]
   public class ExpectedQuality : InfillCriterionBase {
-    #region HL-Constructors, Serialization and Cloning 
+    #region Constructors, Serialization and Cloning 
     [StorableConstructor]
-    private ExpectedQuality(bool deserializing) : base(deserializing) { }
-    private ExpectedQuality(ExpectedQuality original, Cloner cloner) : base(original, cloner) { }
+    protected ExpectedQuality(bool deserializing) : base(deserializing) { }
+    protected ExpectedQuality(ExpectedQuality original, Cloner cloner) : base(original, cloner) { }
     public ExpectedQuality() { }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -42,12 +42,8 @@
 
     public override double Evaluate(RealVector vector) {
-      return RegressionSolution.Model.GetEstimation(vector);
+      return ExpensiveMaximization ? RegressionSolution.Model.GetEstimation(vector) : -RegressionSolution.Model.GetEstimation(vector);
     }
 
-    public override bool Maximization() {
-      return ExpensiveMaximization;
-    }
-
-    protected override void Initialize() {
+    public override void Initialize() {
     }
   }
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedQuantileImprovement.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedQuantileImprovement.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/ExpectedQuantileImprovement.cs	(revision 15064)
@@ -35,5 +35,5 @@
   [StorableClass]
   [Item("ExpectedQuantileImprovement", "Noisy InfillCriterion, Extension of the Expected Improvement as described in \n Noisy expectedimprovement and on - line computation time allocation for the optimization of simulators with tunable fidelitys\r\nPicheny, V., Ginsbourger, D., Richet, Y")]
-  public class ExpectedQuantileImprovement : ExpectedImprovement {
+  public class ExpectedQuantileImprovement : ExpectedImprovementBase {
 
     #region Parameternames
@@ -48,23 +48,19 @@
 
     #region Properties
-
     public int MaxEvaluations => MaxEvaluationsParameter.Value.Value;
     public double Alpha => AlphaParameter.Value.Value;
     [Storable]
     private double Tau;
-
     #endregion
 
     #region HL-Constructors, Serialization and Cloning 
     [StorableConstructor]
-    private ExpectedQuantileImprovement(bool deserializing) : base(deserializing) { }
-
-    private ExpectedQuantileImprovement(ExpectedQuantileImprovement original, Cloner cloner) : base(original, cloner) {
+    protected ExpectedQuantileImprovement(bool deserializing) : base(deserializing) { }
+    protected ExpectedQuantileImprovement(ExpectedQuantileImprovement original, Cloner cloner) : base(original, cloner) {
       Tau = original.Tau;
     }
-
     public ExpectedQuantileImprovement() {
       Parameters.Add(new FixedValueParameter<DoubleValue>(AlphaParameterName, "The Alpha value specifiying the robustness of the \"effective best solution\". Recommended value is 1.0", new DoubleValue(1.0)));
-      Parameters.Add(new ValueParameter<IntValue>(MaxEvaluationsParameterName, "The maximum number of evaluations allowed for EGO", new IntValue(100)));
+      Parameters.Add(new ValueParameter<IntValue>(MaxEvaluationsParameterName, "The maximum number of evaluations allowed for EGO", new IntValue(500)));
       MaxEvaluationsParameter.Hidden = true;
     }
@@ -74,28 +70,19 @@
     #endregion
 
-    public override double Evaluate(RealVector vector) {
-      var model = RegressionSolution.Model as IConfidenceRegressionModel;
-      var s2 = model.GetVariance(vector);
+    protected override double FindBestFitness(IConfidenceRegressionSolution solution) {
+      Tau = RegressionSolution.EstimatedTrainingValues.Zip(solution.ProblemData.TargetVariableTrainingValues, (d, d1) => Math.Abs(d - d1)).Average();
+      Tau = Tau * Tau / (MaxEvaluations - solution.ProblemData.Dataset.Rows % MaxEvaluations + 1);
 
-      var yhat = model.GetEstimation(vector) + Alpha * Math.Sqrt(Tau * s2 / (Tau + s2));
-      var s = Math.Sqrt(s2 * s2 / (Tau + s2));
+      var index = solution.EstimatedTrainingValues.Zip(solution.EstimatedTrainingVariances, (m, s2) => m + Alpha * Math.Sqrt(s2)).ArgMin(x => x);
+      return solution.EstimatedTrainingValues.ToArray()[index];
 
-      return GetEstimatedImprovement(YMin, yhat, s, ExploitationWeight);
     }
 
-    protected override void Initialize() {
-      if (ExpensiveMaximization) throw new NotImplementedException("AugmentedExpectedImprovement for maximization not yet implemented");
-      var solution = RegressionSolution as IConfidenceRegressionSolution;
-      if (solution == null) throw new ArgumentException("can not calculate Augmented EI without a regression solution providing confidence values");
-
-      Tau = RegressionSolution.EstimatedTrainingValues.Zip(RegressionSolution.ProblemData.TargetVariableTrainingValues, (d, d1) => Math.Abs(d - d1)).Average();
-      Tau = Tau * Tau / (MaxEvaluations - RegressionSolution.ProblemData.Dataset.Rows + 1);
-
-      var xss = new RealVector(Encoding.Length);
-      var xssIndex = solution.EstimatedTrainingVariances.Zip(solution.EstimatedTrainingVariances, (m, s2) => m + Alpha * Math.Sqrt(s2)).ArgMin(x => x);
-      var i = solution.ProblemData.TrainingIndices.ToArray()[xssIndex];
-      for (var j = 0; j < Encoding.Length; j++) xss[j] = solution.ProblemData.Dataset.GetDoubleValue(i, j);
-
-      YMin = RegressionSolution.Model.GetEstimation(xss);
+    protected override double Evaluate(RealVector vector, double estimatedFitness, double estimatedStandardDeviation) {
+      var s2 = estimatedStandardDeviation * estimatedStandardDeviation;
+      var penalty = Alpha * Math.Sqrt(Tau * s2 / (Tau + s2));
+      var yhat = estimatedFitness + (ExpensiveMaximization ? -penalty : penalty);
+      var s = Math.Sqrt(s2 * s2 / (Tau + s2));
+      return GetEstimatedImprovement(BestFitness, yhat, s, ExploitationWeight, ExpensiveMaximization);
     }
 
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/InfillCriterionBase.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/InfillCriterionBase.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/InfillCriterionBase.cs	(revision 15064)
@@ -30,14 +30,12 @@
   [StorableClass]
   public abstract class InfillCriterionBase : ParameterizedNamedItem, IInfillCriterion {
-
     [Storable]
-    protected IRegressionSolution RegressionSolution;
+    public IRegressionSolution RegressionSolution { get; set; }
     [Storable]
-    protected bool ExpensiveMaximization;
+    public bool ExpensiveMaximization { get; set; }
     [Storable]
-    protected RealVectorEncoding Encoding;
+    public RealVectorEncoding Encoding { get; set; }
 
     protected InfillCriterionBase(bool deserializing) : base(deserializing) { }
-
     protected InfillCriterionBase(InfillCriterionBase original, Cloner cloner) : base(original, cloner) {
       RegressionSolution = cloner.Clone(original.RegressionSolution);
@@ -48,15 +46,7 @@
 
     public abstract double Evaluate(RealVector vector);
-    public abstract bool Maximization();
+    //public abstract bool Maximization();
 
-    public void Initialize(IRegressionSolution solution, bool expensiveMaximization, RealVectorEncoding encoding) {
-      RegressionSolution = solution;
-      ExpensiveMaximization = expensiveMaximization;
-      Encoding = encoding;
-      Initialize();
-    }
-
-    protected abstract void Initialize();
-
+    public abstract void Initialize();
   }
 }
